﻿////
////////	Loder for mgc2fz.dll (Ver2.1600a)
////
using System;
using System.Text;
using System.Runtime.InteropServices;

namespace m2fz
{
    public class mfz
    {
        public const int TRUE		= 1;
	    public const int FALSE		= 0;
	    public const int YES		= TRUE;
	    public const int NO			= FALSE;
	    public const int NULL		= 0;
	    public const int SUCCESS	= 0;
	    public const int FAILURE	= -1;
        public const int MAX_PATH   = 260;

	    public const int ID_KV40_SIZE		= 192;			// ＩＤサイズ(バイト) プロダクトキーバージョン 4.0
	    public const int ID_KV41_SIZE		= ID_KV40_SIZE;	// ＩＤサイズ(バイト) プロダクトキーバージョン 4.1
	    public const int PRODUCTKEY_SIZE	= 19;			// プロダクトキー用バッファサイズ(バイト)
	    public const int PRODUCTKEY_18		= 18;			// プロダクトキー１８文字
	    public const int PRODUCTKEY_16		= 16;			// プロダクトキー１６文字
	    public const int VALDATIONCODE_SIZE	= 24;			// 認証コードのサイズ(バイト)
	    public const int TIME_SIZE			= 16;			// 時間値のサイズ(バイト)
	    public const int USER_NAME_SIZE		= 17;			// ユーザー名のサイズ
	    public const int USER_NAME_MIN_SIZE	= 4;			// ユーザー名の最小サイズ

        // 構造体
        public struct SYSTEMTIME
        {
            public ushort year;
            public ushort month;
            public ushort dayOfWeek;
            public ushort day;
            public ushort hour;
            public ushort minute;
            public ushort second;
            public ushort milliseconds;
            public void initialize()
            {
                 year = month = dayOfWeek = day = hour = minute = second = milliseconds = 0;
            }
        }


	    //
	    //// mfzInitialize
	    //

        // 引数
        public const int INI_PARAMS_A_SIZE  = 200;
	    public const int INI_PARAMS_B_SIZE  = 28;

        public const uint INI_PRODUCTKEY_VERSION    = 0x0000ffff;
	    public const uint INI_PRODUCTKEY_OPTIONS	= 0xffff0000;
        public const uint INI_TIME_FORMAT           = 0x000f0000;
        public const uint INI_VALDATIONCODE         = 0x00f00000;
	    public const uint INI_PRODUCTKEY_VERSION_40 = 40;
	    public const uint INI_PRODUCTKEY_VERSION_41	= 41;
	    public const uint INI_TIME_FORMAT_A		    = 0x00000000;
	    public const uint INI_TIME_FORMAT_B		    = 0x00010000;
        public const uint INI_TIME_FORMAT_C         = 0x00020000;
        public const uint INI_VALDATIONCODE_HDD     = 0x00000000;	    // 認証コード作成条件にＨＤＤフォーマットナンバーを含める
        public const uint INI_VALDATIONCODE_CPU     = 0x00100000;	    // 認証コード作成条件にＣＰＵの種類を含める
        public const uint INI_VALDATIONCODE_HDD_AND_CPU = 0x00200000;	// INI_VALDATIONCODE_HDD + INI_VALDATIONCODE_CPU
	
        public const uint INI_STANDARD  = INI_PRODUCTKEY_VERSION_41 | INI_TIME_FORMAT_C;
        public const uint INI_LEGACY    = INI_PRODUCTKEY_VERSION_41 | INI_TIME_FORMAT_B;

	
	    // 戻り値
	    public const int INI_ERR_INITIAL_STATE	=  4000;
        public const int INI_ERR_RESOURCE_CRC   = -4000;
	    public const int INI_ERR_RESOURCE		= -4001;
	    public const int INI_ERR_FILE			= -4002;
	    public const int INI_ERR_DLL_VERSION	= -4003;
	
	    // 構造体
	    public struct INI_PARAMS_A
	    {
		    public uint     size;			// この構造体のサイズ
		    public uint     functions;		// プロダクトキーのバージョン
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = ID_KV41_SIZE)]
		    public byte[]	identity;		// アプリケーションＩＤ
            public void initialize()
            {
                size = INI_PARAMS_A_SIZE;
                functions = INI_STANDARD;
                identity = new byte [ID_KV41_SIZE];
            }
	    }

	    public struct INI_PARAMS_B
	    {
		    public uint 		size;			    // この構造体のサイズ
		    public uint 		functions;	        // プロダクトキーのバージョン
		    public uint 		magicCode;		    // ＤＬＬにアクセスするための識別番号
		    public SYSTEMTIME	beginningDate;	// ＤＬＬにＩＤを書き込んだ時間
            public void initialize()
            {
            	size = INI_PARAMS_B_SIZE;
                functions = INI_STANDARD;
                magicCode = 0;
                beginningDate.initialize();
            }
	    }    

		//
		//// mfzGetTimeSpan & mfzGetSystemTime
		//

		// 戻り値
		public const int TMS_INVALID_TIME			= -4100;
		public const int TMS_SUCCESS_AND_TIME_MADE	= 4100;

	    //
	    // mfzGetCode & mfzPutCode
	    //

	    // 戻り値
	    public const int COD_ERR_INITIAL_STATE		=  4200;
	    public const int COD_ERR_LOAD				= -4200;
	    public const int COD_ERR_CRC				= -4201;
	    public const int COD_ERR_NO_TRUNK			= -4202;
	    public const int COD_ERR_RESOURCE			= -4203;
	    public const int COD_ERR_FILE				= -4204;
	    public const int COD_ERR_FILE_NOT_FOUND		= -4205;
	    public const int COD_ERR_INVALID_FILE_NAME	= -4206;

	    //
	    //// mfzCreateTrunk
	    //
	    public const uint CTK_ATTRIBUTE_NORMAL	    = 0x00000080;
	    public const uint CTK_ATTRIBUTE_READONLY    = 0x00000001;
        public const uint CTK_ATTRIBUTE_HIDDEN      = 0x00000002;
        
        // 戻り値
	    public const int CTK_ERR_CRC      = COD_ERR_CRC;
	    public const int CTK_ERR_FILE     = COD_ERR_FILE;
	    public const int CTK_ERR_RESOURCE = COD_ERR_RESOURCE;

        //
	    //// GetTrunkName
	    //
	    public const uint GTN_COMMAND					= 0x000000ff;
	    public const uint GTN_OPTIONS					= 0xffffff00;
	    public const uint GTN_GET_APPDATA_PATH			= 0x00000000;	// Common App path 取得
	    public const uint GTN_GET_TRUNK_PATH			= 0x00000001;	// Trunk file path 取得
	    public const uint GTN_GET_TRUNK_PATH_AND_NAME	= 0x00000002;	// Trunk file name and path 取得
	    public const uint GTN_GET_TRUNK					= 0x00000003;	// Trunk file name 取得
        public const uint GTN_MAKE_DIRECTORY            = 0x00000100;	// ディレクトリ作成

        public const int GTN_CHAR_SIZE = 32;

        //
        //// DLL Load
        //
        private const string DLL_NAME = @"mgc2fz.dll";
        private IntPtr m_module;

        // windows api
        [DllImport("kernel32.dll")]
        static extern IntPtr LoadLibrary(string libFileName);
        [DllImport("kernel32.dll")]
        static extern IntPtr GetProcAddress(IntPtr module, string procName);
        [DllImport("kernel32.dll")]
        static extern int FreeLibrary(IntPtr module);

       
          
        // mfz dll 関数型
        public delegate int INITIALIZEA(ref mfz.INI_PARAMS_A initialParams);
        public delegate int INITIALIZEB(ref mfz.INI_PARAMS_B initialParams);
        public delegate int VERIFYPRODUCTKEY(   [MarshalAs(UnmanagedType.LPStr)]string productKey   );
        public delegate int VERIFYVALIDATIONCODE(   [MarshalAs(UnmanagedType.LPStr)]string userName,
                                                    byte[] validationCode   );
        public delegate int GETVALIDATIONCODE(  [MarshalAs(UnmanagedType.LPStr)]string productKey,
                                                [MarshalAs(UnmanagedType.LPStr)]string userName,
                                                byte[] validationCode   );
        public delegate int GETTIME(    [MarshalAs(UnmanagedType.LPStr)]string userName,
                                        byte[] time );
        public delegate int GETTIMESPAN(    [MarshalAs(UnmanagedType.LPStr)]string userName,
                                            byte[] time );
        public delegate int GETSYSTEMTIME(  [MarshalAs(UnmanagedType.LPStr)]string userName,
                                            byte[] time, 
                                            ref mfz.SYSTEMTIME systemTime   );
        public delegate int CREATETRUNK(    [MarshalAs(UnmanagedType.LPWStr)]string fileName,
                                            uint attributes );
        public delegate int GETCODE(    [MarshalAs(UnmanagedType.LPWStr)]string fileName, 
                                        byte[] validationCode, 
                                        byte[] time,
                                        StringBuilder userName  );
        public delegate int PUTCODE(    [MarshalAs(UnmanagedType.LPWStr)]string fileName, 
                                        byte[] validationCode,
                                        byte[] time,
                                        [MarshalAs(UnmanagedType.LPStr)]string userName );
        public delegate int GETTRUNKNAME(   uint function,
                                            [MarshalAs(UnmanagedType.LPStr)]string manufacturer,
                                            [MarshalAs(UnmanagedType.LPStr)]string productName,
                                            int size,
                                            [MarshalAs(UnmanagedType.LPWStr)]StringBuilder result);
        public delegate int SHOWINPUTBOX(   [MarshalAs( UnmanagedType.LPWStr)]string title,
                                            [MarshalAs( UnmanagedType.LPWStr)]string message,
                                            int figure,
                                            StringBuilder userName,
                                            StringBuilder productKey);
        public delegate int GETFILEVERSION(     [MarshalAs( UnmanagedType.LPWStr)]string file,
                                            ref uint major,
                                            ref uint minor,
                                            ref uint revision,
                                            ref uint bild);
        
        public delegate int GETMAJORVERSION(    [MarshalAs( UnmanagedType.LPWStr)]string file,
                                            ref uint major,
                                                IntPtr minor,
                                                IntPtr revision,
                                                IntPtr bild);
        
        public INITIALIZEA          InitializeA;
        public INITIALIZEB          InitializeB;
        public VERIFYPRODUCTKEY     VerifyProductKey;
        public VERIFYVALIDATIONCODE VerifyValidationCode;
        public GETVALIDATIONCODE    GetValidationCode;
        public GETTIME              GetTime;
        public GETTIMESPAN          GetTimeSpan;
        public GETSYSTEMTIME        GetSystemTime;
        public GETTRUNKNAME         GetTrunkName;
        public CREATETRUNK          CreateTrunk;
        public GETCODE              GetCode;
        public PUTCODE              PutCode;
        public SHOWINPUTBOX         ShowInputBox;
        public GETFILEVERSION       GetFileVersion;
        public GETMAJORVERSION      GetMajorVersion;

       


        //
        //// functions
        //
        public mfz()
        {
            m_module = IntPtr.Zero;
            Load();
        }

        ~mfz()
        {
            UnLoad();
        }

        public int Load()
        {
            int r = FAILURE;
            m_module = LoadLibrary(DLL_NAME);

            if (!m_module.Equals(IntPtr.Zero))
            {
                InitializeA = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzInitialize"), typeof(INITIALIZEA)) as INITIALIZEA;
                InitializeB = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzInitialize"), typeof(INITIALIZEB)) as INITIALIZEB;
                VerifyProductKey = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzVerifyProductKey"), typeof(VERIFYPRODUCTKEY)) as VERIFYPRODUCTKEY;
                VerifyValidationCode = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzVerifyValidationCode"), typeof(VERIFYVALIDATIONCODE)) as VERIFYVALIDATIONCODE;
                GetValidationCode = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetValidationCode"), typeof(GETVALIDATIONCODE)) as GETVALIDATIONCODE;
                GetTime = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetTime"), typeof(GETTIME)) as GETTIME;
                GetTimeSpan = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetTimeSpan"), typeof(GETTIMESPAN)) as GETTIMESPAN;
                GetSystemTime = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetSystemTime"), typeof(GETSYSTEMTIME)) as GETSYSTEMTIME;
                GetTrunkName = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetTrunkName"), typeof(GETTRUNKNAME)) as GETTRUNKNAME;
                CreateTrunk = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzCreateTrunk"), typeof(CREATETRUNK)) as CREATETRUNK;
                GetCode = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetCode"), typeof(GETCODE)) as GETCODE;
                PutCode = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzPutCode"), typeof(PUTCODE)) as PUTCODE;
                ShowInputBox = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzShowInputBox"), typeof(SHOWINPUTBOX)) as SHOWINPUTBOX;

                GetFileVersion = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetFileVersion"), typeof(GETFILEVERSION)) as GETFILEVERSION;
                GetMajorVersion = Marshal.GetDelegateForFunctionPointer
                (GetProcAddress(m_module, "mfzGetFileVersion"), typeof(GETMAJORVERSION)) as GETMAJORVERSION;
                              

                uint major = 0;
                
                GetMajorVersion(DLL_NAME, ref major, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);

                if (major != 2)
                {
                    UnLoad();
                }
                else
                {
                    r = mfz.SUCCESS;
                }
            }
            return r;
        }

        public void UnLoad()
        {
            FreeLibrary(m_module);
            m_module = IntPtr.Zero;
        }

        public int AreYouReady()
        {
            return (m_module.Equals(IntPtr.Zero))? NO : YES;
        }
    }
}