﻿'////
'////////	Loder for mgc2fz.dll (Ver2.1600a)
'////
Imports System.Runtime.InteropServices
Imports System.Runtime.InteropServices.Marshal
Imports System.Text


namespace m2fz

    Module mfz

        Public Const MFZ_TRUE As Integer = 1
        Public Const MFZ_FALSE As Integer = 0
        Public Const MFZ_YES As Integer = True
        Public Const MFZ_NO As Integer = False
        Public Const MFZ_NULL As Integer = 0
        Public Const MFZ_SUCCESS As Integer = 0
        Public Const MFZ_FAILURE As Integer = -1
        Public Const MFZ_MAX_PATH As Integer = 260

        Public Const MFZ_ID_KV40_SIZE As Integer = 192              '// ＩＤサイズ(バイト) プロダクトキーバージョン 4.0
        Public Const MFZ_ID_KV41_SIZE As Integer = MFZ_ID_KV40_SIZE '// ＩＤサイズ(バイト) プロダクトキーバージョン 4.1
        Public Const MFZ_PRODUCTKEY_SIZE As Integer = 19            '// プロダクトキー用バッファサイズ(バイト)
        Public Const MFZ_PRODUCTKEY_18 As Integer = 18              '// プロダクトキー１８文字
        Public Const MFZ_PRODUCTKEY_16 As Integer = 16              '// プロダクトキー１６文字
        Public Const MFZ_VALDATIONCODE_SIZE As Integer = 24         '// 認証コードのサイズ(バイト)
        Public Const MFZ_TIME_SIZE As Integer = 16                  '// 時間値のサイズ(バイト)
        Public Const MFZ_USER_NAME_SIZE As Integer = 17             '// ユーザー名のサイズ
        Public Const MFZ_USER_NAME_MIN_SIZE As Integer = 4          '// ユーザー名の最小サイズ

        '// 構造体
        Public Structure MFZ_SYSTEMTIME
            Dim year As Short
            Dim month As Short
            Dim dayOfWeek As Short
            Dim day As Short
            Dim hour As Short
            Dim minute As Short
            Dim second As Short
            Dim milliseconds As Short

            Public Sub initialize()
                year = month = dayOfWeek = day = hour = minute = second = milliseconds = 0
            End Sub
        End Structure



        '//
        '//// mfzInitialize
        '//

        '// 引数
        Public Const MFZ_INI_PARAMS_A_SIZE As Integer = 200
        Public Const MFZ_INI_PARAMS_B_SIZE As Integer = 28

        Public Const MFZ_PRODUCTKEY_VERSION As Integer = &HFFFF
        Public Const MFZ_PRODUCTKEY_OPTIONS As Integer = &HFFFF0000
        Public Const MFZ_TIME_FORMAT As Integer = &HF0000
        Public Const MFZ_VALDATIONCODE As Integer = &HF00000
        Public Const MFZ_PRODUCTKEY_VERSION_40 As Integer = 40
        Public Const MFZ_PRODUCTKEY_VERSION_41 As Integer = 41
        Public Const MFZ_TIME_FORMAT_A As Integer = &H0
        Public Const MFZ_TIME_FORMAT_B As Integer = &H10000
        Public Const MFZ_TIME_FORMAT_C As Integer = &H20000
        Public Const MFZ_VALDATIONCODE_HDD As Integer = &H0                 '// 認証コード作成条件にＨＤＤフォーマットナンバーを含める
        Public Const MFZ_VALDATIONCODE_CPU As Integer = &H100000            '// 認証コード作成条件にＣＰＵの種類を含める
        Public Const MFZ_VALDATIONCODE_HDD_AND_CPU As Integer = &H200000    '// INI_VALDATIONCODE_HDD + INI_VALDATIONCODE_CPU

        Public Const MFZ_INI_STANDARD As Integer = MFZ_PRODUCTKEY_VERSION_41 Or MFZ_TIME_FORMAT_C
        Public Const MFZ_INI_LEGACY As Integer = MFZ_PRODUCTKEY_VERSION_41 Or MFZ_TIME_FORMAT_B


        '// 戻り値
        Public Const MFZ_INI_ERR_INITIAL_STATE As Integer = 4000
        Public Const MFZ_INI_ERR_RESOURCE_CRC As Integer = -4000
        Public Const MFZ_INI_ERR_RESOURCE As Integer = -4001
        Public Const MFZ_INI_ERR_FILE As Integer = -4002
        Public Const MFZ_INI_ERR_DLL_VERSION As Integer = -4003

        '// 構造体
        Public Structure MFZ_INI_PARAMS_A
            Dim size As Integer             '// この構造体のサイズ
            Dim functions As Integer        '// プロダクトキーのバージョン
            <VBFixedArray(MFZ_ID_KV41_SIZE), MarshalAs(UnmanagedType.ByValArray, SizeConst:=MFZ_ID_KV41_SIZE + 1)> _
            Dim identity() As Byte      '// アプリケーションＩＤ

            Public Sub initialize()
                size = MFZ_INI_PARAMS_A_SIZE
                functions = MFZ_INI_STANDARD
                ReDim identity(MFZ_ID_KV41_SIZE)
            End Sub
        End Structure


        Public Structure MFZ_INI_PARAMS_B
            Dim size As Integer             '// この構造体のサイズ
            Dim functions As Integer        '// プロダクトキーのバージョン
            Dim magicCode As Integer        '// ＤＬＬにアクセスするための識別番号
            Public beginningDate As MFZ_SYSTEMTIME '// ＤＬＬにＩＤを書き込んだ時間

            Public Sub initialize()
                size = MFZ_INI_PARAMS_B_SIZE
                functions = MFZ_INI_STANDARD
                magicCode = 0
                beginningDate.initialize()
            End Sub
        End Structure



        '//
        '//// mfzGetTimeSpan & mfzGetSystemTime
        '//

        '// 戻り値
        Public Const MFZ_TMS_INVALID_TIME As Integer = -4100
        Public Const MFZ_TMS_SUCCESS_AND_TIME_MADE As Integer = 4100

        '//
        '// mfzGetCode & mfzPutCode
        '//

        '// 戻り値
        Public Const MFZ_COD_ERR_INITIAL_STATE As Integer = 4200
        Public Const MFZ_COD_ERR_LOAD As Integer = -4200
        Public Const MFZ_COD_ERR_CRC As Integer = -4201
        Public Const MFZ_COD_ERR_NO_TRUNK As Integer = -4202
        Public Const MFZ_COD_ERR_RESOURCE As Integer = -4203
        Public Const MFZ_COD_ERR_FILE As Integer = -4204
        Public Const MFZ_COD_ERR_FILE_NOT_FOUND As Integer = -4205
        Public Const MFZ_COD_ERR_INVALID_FILE_NAME As Integer = -4206

        '//
        '//// mfzCreateTrunk
        '//
        Public Const MFZ_CTK_ATTRIBUTE_NORMAL As Integer = &H80
        Public Const MFZ_CTK_ATTRIBUTE_READONLY As Integer = &H1
        Public Const MFZ_CTK_ATTRIBUTE_HIDDEN As Integer = &H2

        '// 戻り値
        Public Const MFZ_CTK_ERR_CRC As Integer = MFZ_COD_ERR_CRC
        Public Const MFZ_CTK_ERR_FILE As Integer = MFZ_COD_ERR_FILE
        Public Const MFZ_CTK_ERR_RESOURCE As Integer = MFZ_COD_ERR_RESOURCE

        '//
        '//// GetTrunkName
        '//
        Public Const MFZ_GTN_COMMAND As Integer = &HFF
        Public Const MFZ_GTN_OPTIONS As Integer = &HFFFFFF00
        Public Const MFZ_GTN_GET_APPDATA_PATH As Integer = &H0  '// Common App path 取得
        Public Const MFZ_GTN_GET_TRUNK_PATH As Integer = &H1    '// Trunk file path 取得
        Public Const MFZ_GTN_GET_TRUNK_PATH_AND_NAME As Integer = &H2 '// Trunk file name and path 取得
        Public Const MFZ_GTN_GET_TRUNK As Integer = &H3         '// Trunk file name 取得
        Public Const MFZ_GTN_MAKE_DIRECTORY As Integer = &H100  '// ディレクトリ作成

        Public Const MFZ_GTN_CHAR_SIZE As Integer = 32

        '//
        '//// DLL Load
        '//
        Private Const MFZ_DLL_NAME As String = "mgc2fz.dll"
        Private m_module As IntPtr


        '// windows api
        <DllImport("kernel32.dll", EntryPoint:="LoadLibrary")> _
        Private Function LoadLibrary(ByVal libFileName As String) As IntPtr
        End Function
        <DllImport("kernel32.dll", EntryPoint:="GetProcAddress")> _
        Private Function GetProcAddress(ByVal hModule As IntPtr, ByVal procName As String) As IntPtr
        End Function
        <DllImport("kernel32.dll", EntryPoint:="FreeLibrary")> _
        Private Function FreeLibrary(ByVal hModule As IntPtr) As Integer
        End Function


        '// mfz dll 関数型
        Delegate Function _MFZINITIALIZEA(ByRef initialParams As MFZ_INI_PARAMS_A) As Integer
        Delegate Function _MFZINITIALIZEB(ByRef initialParams As MFZ_INI_PARAMS_B) As Integer
        Delegate Function _MFZVERIFYPRODUCTKEY(<MarshalAs(UnmanagedType.LPStr)> ByVal productKey As String) As Integer
        Delegate Function _MFZVERIFYVALIDATIONCODE(<MarshalAs(UnmanagedType.LPStr)> ByVal userName As String, _
                                                    ByVal validationCode() As Byte) As Integer
        Delegate Function _MFZGETVALIDATIONCODE(<MarshalAs(UnmanagedType.LPStr)> ByVal productKey As String, _
                                                <MarshalAs(UnmanagedType.LPStr)> ByVal userName As String, _
                                                ByVal validationCode() As Byte) As Integer
        Delegate Function _MFZGETTIME(<MarshalAs(UnmanagedType.LPStr)> ByVal userName As String, _
                                         ByVal time() As Byte) As Integer
        Delegate Function _MFZGETTIMESPAN(<MarshalAs(UnmanagedType.LPStr)> ByVal userName As String, _
                                             ByVal time() As Byte) As Integer
        Delegate Function _MFZGETSYSTEMTIME(<MarshalAs(UnmanagedType.LPStr)> ByVal userName As String, _
                                            ByVal time() As Byte, _
                                            ByRef systemTime As MFZ_SYSTEMTIME) As Integer
        Delegate Function _MFZCREATETRUNK(<MarshalAs(UnmanagedType.LPWStr)> ByVal fileName As String, _
                                             ByVal attributes As Integer) As Integer
        Delegate Function _MFZGETCODE(<MarshalAs(UnmanagedType.LPWStr)> ByVal fileName As String, _
                                        ByVal validationCode() As Byte, _
                                         ByVal time() As Byte, _
                                         ByVal userName As StringBuilder) As Integer
        Delegate Function _MFZPUTCODE(<MarshalAs(UnmanagedType.LPWStr)> ByVal fileName As String, _
                                        ByVal validationCode() As Byte, _
                                        ByVal time() As Byte, _
                                        <MarshalAs(UnmanagedType.LPStr)> ByVal userName As String) As Integer
        Delegate Function _MFZGETTRUNKNAME(ByVal functions As Integer, _
                                            <MarshalAs(UnmanagedType.LPStr)> ByVal manufacturer As String, _
                                            <MarshalAs(UnmanagedType.LPStr)> ByVal productName As String, _
                                             ByVal size As Integer, _
                                             ByVal result As StringBuilder) As Integer
        Delegate Function _MFZSHOWINPUTBOX(<MarshalAs(UnmanagedType.LPWStr)> ByVal title As String, _
                                            <MarshalAs(UnmanagedType.LPWStr)> ByVal message As String, _
                                             ByVal figure As Integer, _
                                             ByVal userName As StringBuilder, _
                                             ByVal productKey As StringBuilder) As Integer
        Delegate Function _MFZGETFILEVERSION(<MarshalAs(UnmanagedType.LPWStr)> ByVal file As String, _
                                            ByRef major As Integer, _
                                            ByRef minor As Integer, _
                                            ByRef revision As Integer, _
                                            ByRef bild As Integer) As Integer

        Delegate Function _MFZGETMAJORVERSION(<MarshalAs(UnmanagedType.LPWStr)> ByVal file As String, _
                                                ByRef major As Integer, _
                                                ByVal minor As IntPtr, _
                                                ByVal revision As IntPtr, _
                                                ByVal bild As IntPtr) As Integer

        Public mfzInitializeA As _MFZINITIALIZEA
        Public mfzInitializeB As _MFZINITIALIZEB
        Public mfzVerifyProductKey As _MFZVERIFYPRODUCTKEY
        Public mfzVerifyValidationCode As _MFZVERIFYVALIDATIONCODE
        Public mfzGetValidationCode As _MFZGETVALIDATIONCODE
        Public mfzGetTime As _MFZGETTIME
        Public mfzGetTimeSpan As _MFZGETTIMESPAN
        Public mfzGetSystemTime As _MFZGETSYSTEMTIME
        Public mfzGetTrunkName As _MFZGETTRUNKNAME
        Public mfzCreateTrunk As _MFZCREATETRUNK
        Public mfzGetCode As _MFZGETCODE
        Public mfzPutCode As _MFZPUTCODE
        Public mfzShowInputBox As _MFZSHOWINPUTBOX
        Public mfzGetFileVersion As _MFZGETFILEVERSION


        '// functions
        Public Function Load() As Integer
            Dim r As Integer = MFZ_FAILURE
            m_module = LoadLibrary(MFZ_DLL_NAME)

            If m_module.Equals(IntPtr.Zero) = False Then
                mfzInitializeA = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzInitialize"), GetType(_MFZINITIALIZEA))
                mfzInitializeB = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzInitialize"), GetType(_MFZINITIALIZEB))
                mfzVerifyProductKey = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzVerifyProductKey"), GetType(_MFZVERIFYPRODUCTKEY))
                mfzVerifyValidationCode = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzVerifyValidationCode"), GetType(_MFZVERIFYVALIDATIONCODE))
                mfzGetValidationCode = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetValidationCode"), GetType(_MFZGETVALIDATIONCODE))
                mfzGetTime = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetTime"), GetType(_MFZGETTIME))
                mfzGetTimeSpan = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetTimeSpan"), GetType(_MFZGETTIMESPAN))
                mfzGetSystemTime = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetSystemTime"), GetType(_MFZGETSYSTEMTIME))
                mfzGetTrunkName = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetTrunkName"), GetType(_MFZGETTRUNKNAME))
                mfzCreateTrunk = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzCreateTrunk"), GetType(_MFZCREATETRUNK))
                mfzGetCode = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetCode"), GetType(_MFZGETCODE))
                mfzPutCode = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzPutCode"), GetType(_MFZPUTCODE))
                mfzShowInputBox = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzShowInputBox"), GetType(_MFZSHOWINPUTBOX))
                mfzGetFileVersion = GetDelegateForFunctionPointer _
                (GetProcAddress(m_module, "mfzGetFileVersion"), GetType(_MFZGETFILEVERSION))


                Dim major As Integer = 0
                mfzGetFileVersion(MFZ_DLL_NAME, major, MFZ_NULL, MFZ_NULL, MFZ_NULL)

                If (major <> 2) Then
                    UnLoad()
                Else
                    r = MFZ_SUCCESS
                End If
            End If

            Return r
        End Function

        Public Sub UnLoad()
            FreeLibrary(m_module)
            m_module = IntPtr.Zero
        End Sub

        Public Function AreYouReady() As Integer
            Dim r As Integer
            If m_module.Equals(IntPtr.Zero) Then
                r = MFZ_NO
            Else
                r = MFZ_YES
            End If
            Return r
        End Function



    End Module

End Namespace